import os
import simplekml 
import requests
from shapely.geometry import shape
from shapely.geometry.polygon import orient

def select2kmz(select):

    results = select.results
    kml = simplekml.Kml()
    height = 0
    for acq, tiles in results.acquisitions.items():
        folder = kml.newfolder(name=acq)
        for tile in tiles:
            boundary = folder.newpolygon(name=tile.acquisition_id)
            
            # make sure the geometry is CCW wound
            geom = orient(shape(tile))
            coords = list(geom.exterior.coords)
            boundary.outerboundaryis = [(*t, height) for t in coords]
            boundary.style.linestyle.color = simplekml.Color.red
            boundary.altitudemode = simplekml.AltitudeMode.relativetoground
            boundary.style.polystyle.fill = 0

            try:
                os.mkdir('tiles')
            except:
                pass
            # grab the tile until hrefs work
            filename = f'tiles/{tile.acquisition_id}-{tile.quadkey}.jpg'
            #r = requests.get(tile.thumbnail_url, headers={'Accept': 'image/jpeg'})
            #with open(filename, 'wb') as f:
            #    f.write(r.content)
            overlay = folder.newgroundoverlay(name='')
            overlay.icon.href = filename
            overlay_geom = orient(shape(tile.cell.geom_WGS84))
            quad_pts = list(overlay_geom.exterior.coords)[:4]
            # these need to go ll, lr, ur, rl pairs
            # so we rotate until ll is at the front of the quad
            cx, cy = geom.centroid.coords[0]
            while quad_pts[0][0] >= cx or quad_pts[0][1] >= cy:
                quad_pts.append(quad_pts.pop(0))
            overlay.gxlatlonquad.coords = quad_pts
            overlay.altitude = height
            overlay.altitudemode = simplekml.AltitudeMode.relativetoground
                

        height += 100
    # folder per strip

    # add a polygon per tile
    # add an overlay
        # float by date?
    # add cloud geom
        # get

    # save a thumbnail

    # zip up

    # stream zip bytes
    return kml.kml()